#include <GL/glut.h>

extern "C" {
	#include "jpeglib.h"
}

// Alterada em 16/08/06 para suportar imagens JPEG ao
// invs de BMP - Marcelo Cohen

class ImageClass
{

protected:
	int PosX, PosY;
	float zoomH, zoomV;
	
	void DecodeJPG(jpeg_decompress_struct* cinfo, bool inverte);
	void CarregaJPG(const char *filename, bool inverte = true);

public:
//	AUX_RGBImageRec *Image;
	unsigned char *Image;
	int Largura, Altura;
	int ncomp;					// nmero de componentes na imagem (1-gray, 3-RGB)
	ImageClass(void);
	ImageClass(int sizeX, int sizeY,int n=3);	// default: RGB
	
	int Load(char *);
	void Display(void);
	void Delete(void);
	void DrawPixel(int x, int y, unsigned char r, unsigned char g, unsigned char b);
	void DrawLineH(int y, int x1, int x2, unsigned char r, unsigned char g, unsigned char b);
	void DrawLineV(int x, int y1, int y2,unsigned char r, unsigned char g, unsigned char b );
	void ReadPixel(GLint x, GLint y, unsigned char &r, unsigned char &g, unsigned char &b);
	int GetPointIntensity(int x, int y);
	int SizeX() { return Largura; };
	int SizeY() { return Altura; };
	float GetZoomH() { return zoomH; };
	float GetZoomV() { return zoomV; };
	void SetZoomH(float H) { zoomH = H; };
	void SetZoomV(float V) { zoomV = V; };
	void CopyTo(ImageClass *i);
	void Clear();
	
	unsigned char *GetImagePtr();
	void SetSize(int sizeX, int sizeY,int n=3);	 // default: RGB
	
	void SetPos(int X, int Y);
};
